<template>
    <div class="address">
        <v-row
            :class="[
                { 'pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-col v-if="$vuetify.breakpoint.mdAndUp" cols="3">
                <menu-bar />
            </v-col>
            <v-col>
                <v-row
                    :class="[
                        { 'pt-16 pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        { 'pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
                    ]"
                >
                    <v-col>
                        <h1 class="font-syne-bold">
                            {{ $t('dashboard.menu.ADDRESS') }}
                        </h1>
                    </v-col>
                </v-row>
                <v-row
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        {
                            'pl-16 pr-16 pb-5': $vuetify.breakpoint.mdAndUp,
                        },
                    ]"
                >
                    <v-col cols="12" class="pr-0">
                        <v-btn
                            class="lowercase br-0 pl-10 pr-10 font-syne-bold"
                            color="badge"
                            @click="
                                goToPage(menus.ADDRESS.sub.ADDRESSADD.id, false)
                            "
                            >{{ $t('buttons.addAddressBtn') }}</v-btn
                        >
                    </v-col>
                </v-row>
                <v-row
                    v-if="addresses.length === 0"
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        {
                            'pl-16 pr-16 pb-5': $vuetify.breakpoint.mdAndUp,
                        },
                    ]"
                >
                    <v-col cols="12" class="pr-0">
                        <p class="font-14 font-metropolis-regular text-white">
                            {{ $t('common.noAddress') }}
                        </p>
                    </v-col>
                </v-row>
                <v-row
                    v-for="(address, a) in addresses"
                    v-else
                    :key="'address-' + a"
                    :class="[
                        { 'pl-0 pr-0': $vuetify.breakpoint.smAndDown },
                        {
                            'pl-16 pr-16 pb-5': $vuetify.breakpoint.mdAndUp,
                        },
                    ]"
                >
                    <v-col md="10" cols="6" class="pr-0">
                        <!-- ADDRESSES -->
                        <v-btn v-if="address.isShipping" x-small color="grey">{{
                            $t('common.shipping')
                        }}</v-btn>
                        <v-btn v-if="address.isBilling" x-small color="blue">{{
                            $t('common.billing')
                        }}</v-btn>
                        <p class="font-metropolis-regular mb-0">
                            {{ address.firstName }} {{ address.lastName }}
                        </p>
                        <p
                            class="font-metropolis-regular font-12 text-grey mb-0"
                        >
                            {{ address.address1 }}
                        </p>
                        <p
                            class="font-metropolis-regular font-12 text-grey mb-0"
                        >
                            {{
                                address.address2
                                    ? address.address2 + ', ' + address.city
                                    : address.city
                            }}
                        </p>
                        <p
                            class="font-metropolis-regular font-12 text-grey mb-0"
                        >
                            {{ address.postcode }}, {{ address.state }}
                        </p>
                        <p
                            class="font-metropolis-regular font-12 text-grey mb-0"
                        >
                            {{ address.country }}
                        </p>
                    </v-col>
                    <v-col md="2" cols="6" class="text-right">
                        <v-btn
                            x-small
                            text
                            color="badge"
                            class="mt-5 lowercase"
                            @click="goToPage(address.id, true)"
                            >{{ $t('buttons.editAddressBtn') }}</v-btn
                        >
                        <v-btn
                            v-if="!address.isShipping"
                            x-small
                            text
                            color="badge"
                            class="lowercase"
                            @click="setShipping(address.id)"
                            >{{ $t('buttons.setShippingBtn') }}</v-btn
                        >
                        <v-btn
                            v-if="!address.isBilling"
                            x-small
                            text
                            color="badge"
                            class="lowercase"
                            @click="setBilling(address.id)"
                            >{{ $t('buttons.setBillingBtn') }}</v-btn
                        >
                        <v-btn
                            x-small
                            text
                            color="badge"
                            class="lowercase"
                            @click="deleteAddress(address.id)"
                            >{{ $t('buttons.deleteAddressBtn') }}</v-btn
                        >
                    </v-col>
                </v-row>
            </v-col>
        </v-row>
    </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'
import MenuBar from '~/components/dashboard/menuBar.vue'

Vue.component('menu-bar', MenuBar)

@Component<any>({
    middleware: ['authenticate'],
    head() {
        return {
            titleTemplate: '%s | ' + this.$t('dashboard.menu.HOME'),
            title: this.$t('dashboard.menu.ADDRESS'),
        }
    },
    computed: mapGetters({
        menus: 'menu/getMenuDashboard',
        addresses: 'user/getAddresses',
    }),
})
export default class Address extends Vue {
    // Data
    menus!: any
    selectedPage: Number = 2 // address
    message: any = null
    color: String = ''
    icon: String = ''

    // Method
    goToPage(id: Number, type: Boolean = false) {
        if (type) {
            this.$router.push(this.menus.ADDRESS.path + '/' + id)
        } else {
            switch (id) {
                case this.menus.ADDRESS.sub.ADDRESSADD.id:
                    this.$router.push(this.menus.ADDRESS.sub.ADDRESSADD.path)
                    break

                default:
                    this.$router.push('/')
                    break
            }
        }
    }

    setShipping(id: number) {
        this.$api.user
            .defaultShipping(id)
            .then(async (response) => {
                if (response) {
                    // Set shipping address boolean data
                    this.$store.dispatch('user/setShipping', id)

                    // Trigger get profile data
                    const userProfile = await this.$api.user.profile()
                    this.$store.commit('user/setUser', userProfile.data)

                    // Trigger get addresses list
                    const userAddresses = await this.$api.user.listAddress()
                    this.$store.dispatch(
                        'user/handleAddressApi',
                        userAddresses.data
                    )
                }

                // Display snackbar
                const val = {
                    text: this.$t('snackbar.setShippingAddressSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
            })
            .catch((error) => {
                if (error.response.status === 401) {
                }
            })
    }

    setBilling(id: number) {
        this.$api.user
            .defaultBilling(id)
            .then(async (response) => {
                if (response) {
                    // Set billing address boolean data
                    this.$store.dispatch('user/setBilling', id)

                    // Trigger get profile data
                    const userProfile = await this.$api.user.profile()
                    this.$store.commit('user/setUser', userProfile.data)

                    // Trigger get addresses list
                    const userAddresses = await this.$api.user.listAddress()
                    this.$store.dispatch(
                        'user/handleAddressApi',
                        userAddresses.data
                    )
                }

                // Display snackbar
                const val = {
                    text: this.$t('snackbar.setBillingAddressSuccess'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
            })
            .catch((error) => {
                if (error.response.status === 401) {
                }
            })
    }

    @Debounce(500)
    async deleteAddress(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.user.deleteAddress(id)

            if (deleteResponse) {
                this.$store.commit('user/deleteAddress', id)
                this.message = this.$t('notification.address.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    created() {
        this.$store.dispatch('menu/selectDashboardMenu', this.selectedPage)
    }
}
</script>
